CT_RATooltip_Options = {
};

CT_RATooltip_Setup = {
	currentMap = "";
	isWarrior = true;
};

function CT_RATooltip_LoadDefaults(force)
	for k, v in CT_RATOOLTIP_OPTIONS_DEFAULT do
		if ( CT_RATooltip_Options[k] == nil ) or ( force ) then
			CT_RATooltip_Options[k] = v;
		end
	end
end

function CT_RATooltip_OnLoad()
	--CT_RABoss_AddMod(CT_RATOOLTIPS_TOOLTIP_NAME, CT_RATOOLTIPS_TOOLTIP_NAME_INFO, 1, CT_RABOSS_LOCATIONS_ONYXIASLAIR);
	CT_RATooltip_LoadDefaults();
	
	CT_RATooltip_Saved_UnitFrame_OnEnter = UnitFrame_OnEnter;
	UnitFrame_OnEnter = CT_RATooltip_UnitFrame_OnEnter;
	
	local cmd = "CT_RATOOLTIPS";
	SlashCmdList[cmd] = CT_RATooltip_SlashCommand;
	cmd = "SLASH_"..cmd;
	for k, v in CT_RATOOLTIPS_TOOLTIP_SLASH_COMMANDS do
		setglobal(cmd..k, v);
	end
	
	CT_RATooltipFrame:RegisterEvent("VARIABLES_LOADED");
	CT_RATooltipFrame:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
	CT_RATooltipFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
	CT_RATooltipFrame:RegisterEvent("WORLD_MAP_UPDATE");
	CT_RATooltipFrame:RegisterEvent("MINIMAP_ZONE_CHANGED");
	CT_RATooltipFrame:RegisterEvent("ZONE_CHANGED");
	CT_RATooltipFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
	CT_RATooltipFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
end

function CT_RATooltip_OnEvent()
	if ( event == "VARIABLES_LOADED" ) then
		CT_RATooltip_LoadDefaults();
		return;
	elseif ( event == "UPDATE_MOUSEOVER_UNIT" ) then
		CT_RATooltip_EventHandler_MouseOver();
		return;
	else
		CT_RATooltip_EventHandler_Map();
		return;
	end
end

function CT_RATooltip_OnLoad_TooltipFunctions()
	if ( not TooltipFunctions ) or ( not TooltipFunctions.addHandler ) then
		return false;
	end
	TooltipsFunctions.addHandler ( 
	 	{	
	 		id="TankTargets", -- Custom ID unique to this handler
	 		func=function(type) -- Function called on unit mouseover
				CT_RATooltip_EventHandler_MouseOver();
			end;
	 		text=CT_RATOOLTIPS_TOOLTIP_SHOW_TANK, -- Checkbox text for that handler
	 		helptext=CT_RATOOLTIPS_TOOLTIP_SHOW_TANK_INFO, -- Mouseover text for that handler
	 		default=true, -- default state (true/false)
	 		featureName="", -- String describing the feature "featureName enabled"
	 		keywordCT_RATOOLTIPS_TOOLTIP_KHAOS_KEYWORD 	-- String keyword used for the /tooltip command
		}
 	);
 	return true;
end


function CT_RATooltip_PatchTooltip(unit)
	if ( not CT_RATooltip_Options.enabled ) or ( not UnitExists(unit) ) 
		or ( not CT_RATooltip_Setup.currentMap ) or ( UnitIsPlayer(unit) ) 
		or ( ( CT_RATooltip_Options.onlyIfWarrior ) and ( not CT_RATooltip_Setup.isWarrior ) ) then
		return;
	end
	if ( not CT_RATooltip_Options.allMobs ) then
		local mobs = CT_RATOOLTIPS_TOOLTIP_TARGETED_MOBS[CT_RATooltip_Setup.currentMap];
		if ( not mobs ) or ( type(mobs) ~= "table" ) then
			return;
		end
	end
	if ( ( CT_RATooltip_Options.allMobs ) or ( mobs[UnitName(unit)] ) ) and ( CT_RATarget ) and ( CT_RATarget.MainTanks ) then
		local str = nil;
		for k, v in CT_RATarget.MainTanks do
			if ( UnitIsUnit("raid"..v[1].."target", unit) ) then
				if ( str ) then
					str = str..", ";
				else
					str = "";
				end
				str = str..format(CT_RATOOLTIPS_TOOLTIP_NAME_FORMAT, v[2]);
			end
		end
		if ( str ) then
			GameTooltip:AddLine(format(CT_RATOOLTIPS_TOOLTIP_LINE_FORMAT, str));
			CT_RATooltipMouseoverFixSize();
		end
	end
end

function CT_RATooltip_UnitFrame_OnEnter()
	if ( CT_RATooltip_Options.enabled ) and ( CT_RATooltip_Options.addUnitTooltip ) then
		CT_RATooltip_PatchTooltip(this.unit);
	end
	return CT_RATooltip_Saved_UnitFrame_OnEnter();
end

function CT_RATooltip_EventHandler_MouseOver()
	if ( CT_RATooltip_Options.addMouseoverTooltip ) then
		CT_RATooltip_PatchTooltip("mouseover");
	end
end

function CT_RATooltip_EventHandler_Map()
	if ( event == "PLAYER_ENTERING_WORLD" ) then
		local _, class = UnitClass("player");
		if ( class ~= "WARRIOR" ) then
			CT_RATooltip_Setup.isWarrior = false;
		end
	end
	CT_RATooltip_Setup.currentMap = GetRealZoneText();
	if ( not CT_RATooltip_Setup.currentMap ) then
		CT_RATooltip_Setup.currentMap = "";
	end
end

-- Code ripped from TooltipsKhaos. All credits to that addon for it
	-- fix the size and remove blank lines
	-- note that blank lines can still be created by setting the string to ""
CT_RATooltipMouseoverFixSize = function()
	local tooltipName = "GameTooltip";
	local newWidth = 0;
	local newHeight = 20;
	local lastValid = 0;
	for i = 1, 20 do
		local checkLeftText = getglobal(tooltipName.."TextLeft"..i);
		local checkRightText = getglobal(tooltipName.."TextRight"..i);
		local width = TooltipsFunctions.GetTooltipLineWidth(checkLeftText, checkRightText);
		if (width) then
			if (width > newWidth) then
				newWidth = width;
			end
			newHeight = newHeight + checkLeftText:GetHeight() + 2;
			lastValid = lastValid + 1;
			if (lastValid ~= i) then
				local moveLeftText = getglobal(tooltipName.."TextLeft"..lastValid);
				local moveRightText = getglobal(tooltipName.."TextRight"..lastValid);
				if (moveLeftText ~= nil and checkLeftText ~= nil) then
					moveLeftText:SetText(checkLeftText:GetText());
					moveLeftText:SetTextColor(checkLeftText:GetTextColor());
					if (checkLeftText:IsVisible()) then 
						moveLeftText:Show();
					end
					checkLeftText:SetText("");
					checkLeftText:Hide();
				end
				if (moveRightText ~= nil and checkRightText~=nil) then
					moveRightText:SetText(checkRightText:GetText());
					moveRightText:SetTextColor(checkRightText:GetTextColor());
					if (checkRightText:IsVisible()) then 
						moveRightText:Show();
					end
					checkRightText:SetText("");
					checkRightText:Hide();
				end
			end
		end
	end

	GameTooltip:SetWidth(newWidth);
	GameTooltip:SetHeight(newHeight);
end


function CT_RATooltip_SetOption(option, msg)
	if ( not option ) or ( not msg ) then 
		CT_RATooltip_SlashCommand_Usage(); 
		return; 
	end
	while strsub(msg,1,1) == " " do msg = strsub(msg,2); end
	local newValue = nil;
	local defValue = CT_RATOOLTIP_OPTIONS_DEFAULT[option];
	if ( defValue == true ) or ( defValue == false ) then
		if ( strfind(msg, "true") ) then
			newValue = true;
		elseif( strfind(msg, "false") ) then
			newValue = false;
		elseif( strfind(msg, CT_RATOOLTIPS_TOOLTIP_OPTION_TOGGLE) ) then
			newValue = CT_RATooltip_Options[option];
			if ( not newValue ) then
				newValue = true;
			else
				newValue = false;
			end
		else
			local n = tonumber(msg);
			if ( n ) then
				if ( n == 1 ) then
					newValue = true;
				elseif( n == 0 ) then
					newValue = false;
				elseif( n == -1 ) then
					newValue = CT_RATooltip_Options[option];
					if ( not newValue ) then
						newValue = true;
					else
						newValue = false;
					end
				end
			end
		end
	else
		local n = tonumber(msg);
		if ( n ) then
			newValue = n;
		else
			newValue = msg;
			CT_RATooltip_Options[option] = msg;
		end
	end
	if ( newValue ~= nil ) then
		CT_RATooltip_Options[option] = newValue;
		CT_RATooltip_Print(format(CT_RATOOLTIPS_TOOLTIP_OPTION_SET_FORMAT, option, CT_RATooltip_TranslateOptionValue(newValue)));
	else
		CT_RATooltip_Print(format(CT_RATOOLTIPS_TOOLTIP_OPTION_SET_WRONG, msg, option));
	end
end

function CT_RATooltip_SlashCommand(msg)
	local lmsg = strlower(msg);
	local tmp;
	for k, v in CT_RATOOLTIP_OPTIONS_DEFAULT do
		tmp = strlower(k);
		local i = strfind(lmsg, tmp);
		if ( i ) then
			local rest = strsub(msg, strlen(k)+1);
			while strsub(rest,1,1) == " " do rest = strsub(rest,2); end
			CT_RATooltip_SetOption(k, rest);
			return;
		end
	end
	CT_RATooltip_SlashCommand_Usage();
end

function CT_RATooltip_TranslateOptionValue(value)
	if ( value == true ) then
		return "true";
	elseif ( value == false ) then
		return "false";
	elseif ( value == nil ) then
		return "<nil>";
	end
	return value;
end

function CT_RATooltip_SlashCommand_Usage()
	for k, v in CT_RATOOLTIPS_TOOLTIP_SLASH_USAGE do
		CT_RATooltip_Print(v);
	end
	for k, v in CT_RATOOLTIP_OPTIONS_DEFAULT do
		local value = CT_RATooltip_Options[k];
		if ( value == nil ) then
			value = CT_RATooltip_TranslateOptionValue(false);
		else
			value = CT_RATooltip_TranslateOptionValue(value);
		end
		CT_RATooltip_Print(format(CT_RATOOLTIPS_TOOLTIP_OPTION_VIEW_FORMAT, k, value));
	end
	
end

function CT_RATooltip_Print(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
end
